import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "../../../common";
export interface ZkStack_CustomGasToken_AdapterInterface extends utils.Interface {
    functions: {
        "BRIDGE_HUB()": FunctionFragment;
        "CHAIN_ID()": FunctionFragment;
        "CUSTOM_GAS_TOKEN()": FunctionFragment;
        "CUSTOM_GAS_TOKEN_FUNDER()": FunctionFragment;
        "L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT()": FunctionFragment;
        "L1_WETH()": FunctionFragment;
        "L2_GAS_LIMIT()": FunctionFragment;
        "L2_REFUND_ADDRESS()": FunctionFragment;
        "SHARED_BRIDGE()": FunctionFragment;
        "relayMessage(address,bytes)": FunctionFragment;
        "relayTokens(address,address,uint256,address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "BRIDGE_HUB" | "CHAIN_ID" | "CUSTOM_GAS_TOKEN" | "CUSTOM_GAS_TOKEN_FUNDER" | "L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT" | "L1_WETH" | "L2_GAS_LIMIT" | "L2_REFUND_ADDRESS" | "SHARED_BRIDGE" | "relayMessage" | "relayTokens"): FunctionFragment;
    encodeFunctionData(functionFragment: "BRIDGE_HUB", values?: undefined): string;
    encodeFunctionData(functionFragment: "CHAIN_ID", values?: undefined): string;
    encodeFunctionData(functionFragment: "CUSTOM_GAS_TOKEN", values?: undefined): string;
    encodeFunctionData(functionFragment: "CUSTOM_GAS_TOKEN_FUNDER", values?: undefined): string;
    encodeFunctionData(functionFragment: "L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT", values?: undefined): string;
    encodeFunctionData(functionFragment: "L1_WETH", values?: undefined): string;
    encodeFunctionData(functionFragment: "L2_GAS_LIMIT", values?: undefined): string;
    encodeFunctionData(functionFragment: "L2_REFUND_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "SHARED_BRIDGE", values?: undefined): string;
    encodeFunctionData(functionFragment: "relayMessage", values: [string, BytesLike]): string;
    encodeFunctionData(functionFragment: "relayTokens", values: [string, string, BigNumberish, string]): string;
    decodeFunctionResult(functionFragment: "BRIDGE_HUB", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "CHAIN_ID", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "CUSTOM_GAS_TOKEN", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "CUSTOM_GAS_TOKEN_FUNDER", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "L1_WETH", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "L2_GAS_LIMIT", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "L2_REFUND_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "SHARED_BRIDGE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "relayMessage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "relayTokens", data: BytesLike): Result;
    events: {
        "MessageRelayed(address,bytes)": EventFragment;
        "TokensRelayed(address,address,uint256,address)": EventFragment;
        "ZkStackMessageRelayed(bytes32)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "MessageRelayed"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "TokensRelayed"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "ZkStackMessageRelayed"): EventFragment;
}
export interface MessageRelayedEventObject {
    target: string;
    message: string;
}
export type MessageRelayedEvent = TypedEvent<[
    string,
    string
], MessageRelayedEventObject>;
export type MessageRelayedEventFilter = TypedEventFilter<MessageRelayedEvent>;
export interface TokensRelayedEventObject {
    l1Token: string;
    l2Token: string;
    amount: BigNumber;
    to: string;
}
export type TokensRelayedEvent = TypedEvent<[
    string,
    string,
    BigNumber,
    string
], TokensRelayedEventObject>;
export type TokensRelayedEventFilter = TypedEventFilter<TokensRelayedEvent>;
export interface ZkStackMessageRelayedEventObject {
    canonicalTxHash: string;
}
export type ZkStackMessageRelayedEvent = TypedEvent<[
    string
], ZkStackMessageRelayedEventObject>;
export type ZkStackMessageRelayedEventFilter = TypedEventFilter<ZkStackMessageRelayedEvent>;
export interface ZkStack_CustomGasToken_Adapter extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: ZkStack_CustomGasToken_AdapterInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        BRIDGE_HUB(overrides?: CallOverrides): Promise<[string]>;
        CHAIN_ID(overrides?: CallOverrides): Promise<[BigNumber]>;
        CUSTOM_GAS_TOKEN(overrides?: CallOverrides): Promise<[string]>;
        CUSTOM_GAS_TOKEN_FUNDER(overrides?: CallOverrides): Promise<[string]>;
        L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT(overrides?: CallOverrides): Promise<[BigNumber]>;
        L1_WETH(overrides?: CallOverrides): Promise<[string]>;
        L2_GAS_LIMIT(overrides?: CallOverrides): Promise<[BigNumber]>;
        L2_REFUND_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        SHARED_BRIDGE(overrides?: CallOverrides): Promise<[string]>;
        relayMessage(target: string, message: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<ContractTransaction>;
        relayTokens(l1Token: string, l2Token: string, amount: BigNumberish, to: string, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<ContractTransaction>;
    };
    BRIDGE_HUB(overrides?: CallOverrides): Promise<string>;
    CHAIN_ID(overrides?: CallOverrides): Promise<BigNumber>;
    CUSTOM_GAS_TOKEN(overrides?: CallOverrides): Promise<string>;
    CUSTOM_GAS_TOKEN_FUNDER(overrides?: CallOverrides): Promise<string>;
    L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT(overrides?: CallOverrides): Promise<BigNumber>;
    L1_WETH(overrides?: CallOverrides): Promise<string>;
    L2_GAS_LIMIT(overrides?: CallOverrides): Promise<BigNumber>;
    L2_REFUND_ADDRESS(overrides?: CallOverrides): Promise<string>;
    SHARED_BRIDGE(overrides?: CallOverrides): Promise<string>;
    relayMessage(target: string, message: BytesLike, overrides?: PayableOverrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    relayTokens(l1Token: string, l2Token: string, amount: BigNumberish, to: string, overrides?: PayableOverrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    callStatic: {
        BRIDGE_HUB(overrides?: CallOverrides): Promise<string>;
        CHAIN_ID(overrides?: CallOverrides): Promise<BigNumber>;
        CUSTOM_GAS_TOKEN(overrides?: CallOverrides): Promise<string>;
        CUSTOM_GAS_TOKEN_FUNDER(overrides?: CallOverrides): Promise<string>;
        L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT(overrides?: CallOverrides): Promise<BigNumber>;
        L1_WETH(overrides?: CallOverrides): Promise<string>;
        L2_GAS_LIMIT(overrides?: CallOverrides): Promise<BigNumber>;
        L2_REFUND_ADDRESS(overrides?: CallOverrides): Promise<string>;
        SHARED_BRIDGE(overrides?: CallOverrides): Promise<string>;
        relayMessage(target: string, message: BytesLike, overrides?: CallOverrides): Promise<void>;
        relayTokens(l1Token: string, l2Token: string, amount: BigNumberish, to: string, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "MessageRelayed(address,bytes)"(target?: null, message?: null): MessageRelayedEventFilter;
        MessageRelayed(target?: null, message?: null): MessageRelayedEventFilter;
        "TokensRelayed(address,address,uint256,address)"(l1Token?: null, l2Token?: null, amount?: null, to?: null): TokensRelayedEventFilter;
        TokensRelayed(l1Token?: null, l2Token?: null, amount?: null, to?: null): TokensRelayedEventFilter;
        "ZkStackMessageRelayed(bytes32)"(canonicalTxHash?: null): ZkStackMessageRelayedEventFilter;
        ZkStackMessageRelayed(canonicalTxHash?: null): ZkStackMessageRelayedEventFilter;
    };
    estimateGas: {
        BRIDGE_HUB(overrides?: CallOverrides): Promise<BigNumber>;
        CHAIN_ID(overrides?: CallOverrides): Promise<BigNumber>;
        CUSTOM_GAS_TOKEN(overrides?: CallOverrides): Promise<BigNumber>;
        CUSTOM_GAS_TOKEN_FUNDER(overrides?: CallOverrides): Promise<BigNumber>;
        L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT(overrides?: CallOverrides): Promise<BigNumber>;
        L1_WETH(overrides?: CallOverrides): Promise<BigNumber>;
        L2_GAS_LIMIT(overrides?: CallOverrides): Promise<BigNumber>;
        L2_REFUND_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        SHARED_BRIDGE(overrides?: CallOverrides): Promise<BigNumber>;
        relayMessage(target: string, message: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<BigNumber>;
        relayTokens(l1Token: string, l2Token: string, amount: BigNumberish, to: string, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        BRIDGE_HUB(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        CHAIN_ID(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        CUSTOM_GAS_TOKEN(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        CUSTOM_GAS_TOKEN_FUNDER(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        L1_GAS_TO_L2_GAS_PER_PUB_DATA_LIMIT(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        L1_WETH(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        L2_GAS_LIMIT(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        L2_REFUND_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        SHARED_BRIDGE(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        relayMessage(target: string, message: BytesLike, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
        relayTokens(l1Token: string, l2Token: string, amount: BigNumberish, to: string, overrides?: PayableOverrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
    };
}
